///  + 1 
unit GData;

{$reference 'System.Windows.Forms.dll'}
{$reference 'System.Drawing.dll'}
uses
  system.Drawing,
  //graphabchelper,
  //graphabc,
  //abcobjects,
  //  ?  ?
  System.Windows.Forms;

const
  Debaging = false;

function GetDesktopWindow: system.IntPtr;
external 'User32.dll' name 'GetDesktopWindow';

function GetWindowRect(hWnd: system.IntPtr; var lpRect:system.Drawing.Rectangle): integer;
external 'User32.dll' name 'GetWindowRect';

function FreeConsole: boolean;
 external 'kernel32.dll' name 'FreeConsole';
 
var
  MainForm: System.Windows.Forms.Form;
  FormThread, MainThread: system.Threading.Thread;
  gr: Graphics;
  FormClose: procedure;
  WW, WH: integer;

procedure _FClose(sender: object; e: FormClosingEventArgs);
begin
  {}
  system.Diagnostics.Process.GetCurrentProcess.Kill;
  {}
  e.Cancel := true;
  if (e.CloseReason = system.Windows.Forms.CloseReason.TaskManagerClosing) or (e.CloseReason = system.Windows.Forms.CloseReason.WindowsShutDown) then
  begin
    if FormClose <> nil then FormClose;
    system.Diagnostics.Process.GetCurrentProcess.Kill;
  end;
end;

procedure InitForm;
begin
  MainForm := new Form;
  MainForm.FormClosing += _FClose;
  //MainForm.StartPosition := FormStartPosition.WindowsDefaultLocation;//ToDo
  MainForm.FormBorderStyle := system.Windows.Forms.FormBorderStyle.None;
  MainForm.WindowState := FormWindowState.Maximized;
  
  //MainForm.WindowState := FormWindowState.Minimized;
  
  {
  MainForm.AllowTransparency := true;
  MainForm.TransparencyKey := Color.White;
  //}//?
  
  MainForm.BackColor := system.Drawing.Color.White;
end;

procedure _StartForm;
begin
  system.Windows.Forms.Application.Run(MainForm);
end;

procedure StartForm;
begin
  FreeConsole;
  FormThread := new System.Threading.Thread(_StartForm);
  FormThread.Start;
  MainThread := system.Threading.Thread.CurrentThread;
  while not MainForm.Created do sleep(1);
  if not Debaging then
  gr := Graphics.FromHwnd(MainForm.Handle);
end;

begin
  begin
    var a: system.Drawing.Rectangle;
    GetWindowRect(GetDesktopWindow, a);
    WW := a.Width;
    WH := a.Height;
  end;
end.